/*--------------  FrvBuf.h by B.Mours Sept 14, 2000--------------------------*/

#ifndef FRVBUF
#define FRVBUF

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif

#include "FrameL.h"

#ifdef __cplusplus
extern "C" {
#endif

struct FrvBuf {              /*  This is the FrVect Buffering object         */
                             /*--------------------- input data -------------*/
  int nDataOut;              /* output vector size (number of bin)           */
  int step;                  /* step size (number of output bins)            */
  int outType;               /* type for the output vector(-1 means as input)*/
  int decimate;              /* decimation (yet not implemented)             */
                             /*------------------- internal data ------------*/
  char* startPtr;            /* = output->data                               */
  long restSize;             /* remaining size (in bytes) stored in output   */
  long gapSize;              /* gap size (in bytes)                          */
  long vectSize;             /* input vector size in bytes                   */
  long outSize;              /* output buffer size in bytes                  */
  long stepSize;             /* step size in bytes                           */
  long overSize;             /* overlaping data size = outSize- stepSize     */
  long lastCallIsFeed;       /* flag                                         */
                             /* ------------output-------------------------  */
  FrVect *output;            /* output data                                  */
};

typedef struct FrvBuf FrvBuf;

void    FrvBufFree   (FrvBuf* buffer);
int     FrvBufFeed   (FrvBuf *buffer, FrVect *vect);
int     FrvBufGetNext(FrvBuf *buffer);
int     FrvBufInit   (FrvBuf *buffer, FrVect *vect); 
FrvBuf* FrvBufNew(int outSize,int step,int outType,int decimate);

#ifdef __cplusplus
}
#endif

#endif



