#include "fastGlitch.hh"

#ifdef _USE_FASTAUDIO_

#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <stdio.h>
#include <math.h>
#include <TSeries.hh>

#define BUF_SIZE 4096*40*4
int audio_fd;
unsigned char audio_buffer[BUF_SIZE];

char DEVICE_NAME[]="/dev/dsp";


void playTSeries(TSeries& ts,int debug) {
  int speed;
  int N;
  int nn;
  int ii;
  double max=0;
  double v;
  int format=AFMT_S16_NE;
  int channels = 2;
  int val;
  if((audio_fd = open(DEVICE_NAME, O_RDWR, 0)) == -1) { printf("open error\n"); }
  speed=int(1.0/ts.getTStep());
  if(debug) cout <<"playTSeries: speed    = "<<speed<<endl;
  if(debug) cout <<"playTSeries: format   = "<<format<<endl;  
  if(debug) cout <<"playTSeries: chann    = "<<channels<<endl;  
  if(ioctl(audio_fd,SNDCTL_DSP_SPEED, &speed)==-1) { printf("sampling rate error"); }
  if(ioctl(audio_fd,SNDCTL_DSP_SETFMT, &format)==-1) { printf("format error"); }
  if(ioctl(audio_fd,SNDCTL_DSP_CHANNELS, &channels)==-1) { printf("channels error"); }

  if(debug) cout <<"playTSeries: HW-speed = "<<speed<<endl;  
  if(debug) cout <<"playTSeries: HWformat = "<<format<<endl;  
  if(debug) cout <<"playTSeries: HWchann  = "<<channels<<endl;  
  N=ts.getNSample();
  if(debug) cout <<"playTSeries: N        = "<<N<<endl;
  if(debug) cout <<"playTSeries: BUF_SIZE = "<<BUF_SIZE<<endl;  
  double *buf=new double[N];
  ts.getData(N,buf);
  for(nn=0;nn<N;++nn) {
    v=buf[nn];
    if(v>max) max=v;
    if(-v>max) max=-v;
  }
  if(debug) cout <<"playTSeries: max      = "<<max<<endl;
  
  for(nn=0;nn<N;) {
    for(ii=0;ii<BUF_SIZE && nn<N;) {
      val=int(256.0*128.0*buf[nn]/max);
      //val=int(80.0*sin(2*3.1415*double(nn)/double(speed)*200.0));
      audio_buffer[ii]=(unsigned char)(val & 0xff);
      ++ii;
      audio_buffer[ii]=(unsigned char)((val >> 8)& 0xff);      
      ++ii;
      audio_buffer[ii]=(unsigned char)(val & 0xff);
      ++ii;
      audio_buffer[ii]=(unsigned char)((val >> 8)& 0xff);
      ++nn;
      ++ii;
    }
  int len;
  if((len = write(audio_fd,audio_buffer,ii)) == -1) { printf("write error\n"); }
  if(debug) cout <<"playTSeries: len      = "<<len<<endl;
  }
  
  delete buf;
  close(audio_fd);
  
}
#endif
